;======================================================================;
;                             Marienbad v1.1                           ;
;                         by Guillaume de Vivies                       ;
;                               2000/02/25                             ;
;                           Copyright 2000 GdV                         ;
;                          All rigths reserved.                        ;
;======================================================================;

         include    "doorsos.h"
         include    "userlib.h"
         include    "graphlib.h"
         
         xdef       _main
         xdef       _comment
         xdef       _ti89
 
_main    move.w     #$0700,d0
         trap       #1
         bclr.b     #2,($600001)
         move.l     ($64),old_int
         move.l     #new_int,($64)
         bset.b     #2,($600001)
         trap       #1

         clr.b      TI92X
         clr.b      TI92Y
         tst.b      CALCULATOR               ;Sur quelle calculette on est ?
         beq        ini_scr
         move.b     #38,TI92X                ;ajustement horizontal pour TI-92
         move.b     #14,TI92Y                ;ajustement vertical pour TI-92

ini_scr  jsr        graphlib::clr_scr        ;Efface l'cran

         move.w     #38,d0
         add.b      TI92X,d0
         move.w     #1,d1
         add.b      TI92Y,d1
         move.l     #title,a0
         jsr        graphlib::put_sprite     ;Affiche le titre

         clr.w      d3
         sub.b      #4,d0
         add.b      #4,d1
         move.w     d1,d2
         add.b      #2,d2
         jsr        graphlib::vert           ;----<          >----
         add.b      #92,d0
         jsr        graphlib::vert
         add.b      #1,d1
         move.w     d0,d2
         add.b      #23,d2
         jsr        graphlib::horiz
         sub.b      #92,d0
         sub.b      #140,d2
         jsr        graphlib::horiz

         lea        version(pc),a0
         move.w     #60,d5
         move.w     #13,d6
         bsr        string                   ;Affiche version et auteur

         lea        colstr(pc),a0
         move.w     #23,d5
         move.w     #81,d6
         move.w     #1,d3
         bsr        string                   ;Affiche 1 2 3 4 5 6 7

         lea        num(pc),a0
         move.w     #7,d0
\mt_loop move.w     #7,d1                    ;Initialisation de la liste num
         sub.b      d0,d1
         lsl.b      #1,d1
         move.w     d0,0(a0,d1)
         dbra.s     d0,\mt_loop
         move.w     #6,d4

\cl_loop move.w     #6,d5                    ;Affiche les briques
         sub.b      d4,d5 
\rw_loop move.w     d4,d2
         lea        xcol(pc),a0
         lsl.b      #1,d2
         move.w     0(a0,d2),d0
         add.b      TI92X,d0
         move.w     d5,d2
         lea        yrow(pc),a0
         lsl.b      #1,d2
         move.w     0(a0,d2),d1
         add.b      TI92Y,d1
         move.l     #sprite,a0
         jsr        graphlib::put_sprite
         dbra.s     d5,\rw_loop
         dbra.s     d4,\cl_loop

         move.w     #57,d0
         add.b      TI92X,d0
         move.w     #92,d1
         add.b      TI92Y,d1
         move.w     d1,d2
         add.b      #10,d2                   ; _____ _____ _____
         jsr        graphlib::vert           ; _____|_____|_____|
         add.b      #46,d0                 
         jsr        graphlib::vert
         move.w     #11,d0
         move.w     #92,d1
         move.w     #138,d2
         move.w     #10,d3
         bsr        frame

         move.w     #13,d5                   ;Affiche les scores
         move.w     #95,d6
         lea        name1(pc),a0
         bsr        string

         move.w     #59,d5
         move.w     #95,d6
         lea        name2(pc),a0
         bsr        string

         move.w     #105,d5
         move.w     #95,d6
         lea        name3(pc),a0
         bsr        string

         move.w     score1,d0
         move.w     #44,d5
         move.w     #95,d6
         bsr        print

         move.w     score2,d0
         move.w     #90,d5
         move.w     #95,d6
         bsr        print

         move.w     score3,d0
         move.w     #136,d5
         move.w     #95,d6
         bsr        print

         move.w     #55,d0
         add.b      TI92X,d0
         move.w     #37,d1
         add.b      TI92Y,d1
         move.w     #51,d2 
         move.w     #20,d3                   ;Sauvegarde la partie de l'ecran
         jsr        graphlib::scrtomem       ;crase par le menu

         move.w     d4,a2
         add.b      #3,d1
         move.w     #19,d3
         move.w     #1,d4
         jsr        graphlib::fill
  
         move.w     #55,d0
         move.w     #40,d1
         bsr        frame                    ;Affiche le menu

         lea        ti(pc),a0
         move.w     #60,d5
         move.w     #43,d6
         clr.w      d3
         bsr        string

         move.w     #89,d0
         tst.b      CALCULATOR
         beq        \89
         move.w     #92,d0
\89      move.w     #70,d5
         move.w     #43,d6
         bsr        print

         lea        player(pc),a0
         move.w     #58,d5
         move.w     #52,d6
         bsr        string

         move.w     #56,d0
         add.b      TI92X,d0
         move.w     #41,d1
         add.b      TI92Y,d1
         move.w     #49,d2 
         move.w     #8,d3
         clr.w      d4
         jsr        graphlib::fill

         clr.w      d7                       ;d7: flag de la slection
         bsr        key_off
         tst.b      end_flag                 ;end_flag=1 => normal
         bne        \menu                    ;end_flag=0 => [ESC]-[ON]
         addi.w     #1,counter
         tst.b      stk_flag                 ;mme si le joueur a quitt la
         beq        \menu                    ;partie prcdente avec [ESC]-[ON]
         move.w     #1,counter               ;on comptabilise la dfaite.
         clr.b      stk_flag

\menu    tst.b      CALCULATOR               ;On teste les touches
         beq        \89pad
         move.w     #%1111111011111111,d0    ;touche [ESC]
         bsr        get_key
         btst.b     #6,d0
         beq        \exit
         move.w     #%1111110111111111,d0    ;touche [ENTER]
         bsr        get_key
         btst.b     #1,d0
         beq        \begin
         move.w     #%1111111110111111,d0    ;touche [ENTER]
         bsr        get_key
         btst.b     #6,d0
         beq        \begin         
         move.w     #%1111111111111110,d0    ;touches [HAUT] et [BAS]
         bsr        get_key
         not        d0
         andi       #%0000000010100000,d0
         bne        \move
         bsr        on_off                   ;touche [ON] 
         bra        \menu
\89pad   move.w     #%10111111,d0            ;touche [ESC]
         bsr        get_key
         btst.b     #0,d0
         beq        \exit
         move.w     #%11111101,d0            ;touche [ENTER]
         bsr        get_key
         btst.b     #0,d0
         beq        \begin
         move.w     #%11111110,d0            ;touches [HAUT] et [BAS]
         bsr        get_key
         not        d0
         andi       #%0101,d0
         bne        \move
         bsr        on_off                   ;touche [ON]
         bra        \menu

\exit    bsr        key_off                  ;Attend que [ESC] soit relache
         bsr        int_on
         rts                                 ;Retourne au TIOS

\move    move.w     #56,d0
         add.b      TI92X,d0
         move.w     #41,d1
         add.b      TI92Y,d1
         move.w     #17,d3
         jsr        graphlib::fill           ;Inverse la slection
         bchg       #0,d7
         bsr        key_off
         bra        \menu

\begin   clr.b      end_flag                 ;On commence la partie
         move.w     #55,d0
         add.b      TI92X,d0
         move.w     #37,d1
         add.b      TI92Y,d1
         move.w     #51,d2 
         move.w     #20,d3
         move.w     a2,d4
         jsr        graphlib::memtoscr       ;Restore les briques crases
         bsr        stk_str
         tst.b      d7                       ;Si le joueur commence,
         bne        input                    ;on va au label "input"

rand_alg move.w     #7,d0
         jsr        userlib::random          ;Une colonne au hazard
         add.b      #1,d0
         move.w     d0,d4
         bsr        get_num 
         tst.b      d0
         beq        rand_alg
         move.b     d0,d5
         sub.b      #1,d0
         jsr        userlib::random          ;Un nombre de brique 
         add.b      #1,d0                    ;enlever au hazard
         move.w     d0,d3
         bra        output

input    clr.w      d3
         clr.w      d4

\in_loop move.w     #1,d1                    ;On teste les touches
         tst.b      CALCULATOR
         beq        \89keys
         move.w     #%1111111011111111,d0    ;touche [ESC]
         bsr        get_key
         btst.b     #6,d0
         beq        \esc
         move.w     #%1111111111111101,d0    ;touches [1],[2],[3]
         bsr        get_key
         btst.b     #5,d0
         beq        \un
         btst.b     #6,d0
         beq        \deux
         btst.b     #7,d0
         beq        \trois
         move.w     #%1111111111111011,d0    ;touches [4],[5],[6]
         bsr        get_key
         btst.b     #5,d0
         beq        \quatre
         btst.b     #6,d0
         beq        \cinq
         btst.b     #7,d0
         beq        \six
         move.w     #%1111111111110111,d0    ;touche [7]
         bsr        get_key
         btst.b     #5,d0
         beq        \sept
         move.w     #%1111110111111111,d0    ;touche [ENTER]
         bsr        get_key
         btst.b     #1,d0
         beq        \enter
         move.w     #%1111111110111111,d0    ;touche [ENTER]
         bsr        get_key
         btst.b     #6,d0
         beq        \enter
         bsr        on_off                   ;touche [ON]
         bra        \in_loop
\89keys  move.w     #%10111111,d0            ;touche [ESC]
         bsr        get_key
         btst.b     #0,d0
         beq        \esc
         move.w     #%11111011,d0            ;touches [3],[6]
         bsr        get_key
         btst.b     #1,d0
         beq        \trois
         btst.b     #2,d0
         beq        \six
         move.w     #%11110111,d0            ;touches [2],[5]
         bsr        get_key
         btst.b     #1,d0
         beq        \deux
         btst.b     #2,d0
         beq        \cinq
         move.w     #%11101111,d0            ;touches [1],[4],[7]
         bsr        get_key
         btst.b     #1,d0
         beq        \un
         btst.b     #2,d0
         beq        \quatre
         btst.b     #3,d0
         beq        \sept
         move.w     #%11111101,d0            ;touche [ENTER]
         bsr        get_key
         btst.b     #0,d0
         beq        \enter
         bsr        on_off                   ;touche [ON]
         bra        \in_loop

\esc     move.b     #1,end_flag
         move.w     counter,d7
         addi.w     #1,counter               ;On compte la partie
         tst.b      stk_flag                 ;comme une dfaite
         beq        ini_scr
         move.w     #1,counter
         clr.b      stk_flag
         cmp.w      score3,d7                ;On vrifie le score du joueur
         bhi        place
         bra        ini_scr                  ;On retourne au dbut

\sept    addi.b     #1,d1
\six     addi.b     #1,d1
\cinq    addi.b     #1,d1
\quatre  addi.b     #1,d1
\trois   addi.b     #1,d1
\deux    addi.b     #1,d1
\un      move.w     d1,d0                    ;d0: n de la colonne joue
         jsr        get_num
         move.w     d0,d6
         sub.b      d3,d6
         tst.b      d6                       ;Colonne vide ?
         beq        \in_loop
         tst.b      d4                       ;1re brique enleve ?
         bne        \next
         move.w     d1,d4
\next    cmp.b      d1,d4                    ;Est-ce toujours la mme
         bne        \in_loop                 ;colonne ?
         move.w     d1,d0
         move.w     d6,d1
         bsr        erase
         add.b      #1,d3
         bsr        key_off                  ;Attend que la touche soit relache                
         bra        \in_loop

\enter   tst.b      d4                       ;Au moins une brique a-t-elle
         beq        \in_loop                 ;t enleve ?
         move.w     d4,d0
         bsr        get_num
         move.w     d0,d7
         sub.b      d3,d7
         bsr        put_num                  ;Mise a jour de la liste num

         clr.b      d6
         move.w     #6,d1
\loop_1  move.w     d1,d0
         add.b      #1,d0
         bsr        get_num
         eor        d0,d6
         dbra.s     d1,\loop_1
         tst.b      d6
         beq        rand_alg
         move.w     d6,a1

\loop_2  move.w     #7,d0
         jsr        userlib::random
         add.b      #1,d0
         move.w     d0,d4                    
         bsr        get_num
         move.w     d0,d5
         move.w     a1,d6
         eor        d5,d6
         cmp.b      d5,d6
         bcc        \loop_2
         move.w     d5,d3
         sub.b      d6,d3

output   bsr        win_tst
         cmp.b      #1,d6                    ;Le joueur a-t-il gagn ?
         beq        win
         cmp.b      #1,d1
         bne        \n_erase

         add.b      #1,d6
         sub.b      d5,d6
         andi       #1,d6
         move.w     d5,d3
         sub.b      d6,d3   

\n_erase move.w     d5,d7
         sub.b      d3,d7
         bsr        delay                    ;Pour faire croire que la TI
         bsr        delay                    ;a rflechi quelque temps
\er_loop bsr        delay
         move.w     d4,d0
         move.w     d5,d1 
         bsr        erase
         move.b     d7,d0
         add.b      #1,d0
         cmp.b      d0,d5 
         dbeq.s     d5,\er_loop

         bsr        put_num                  ;Mise a jour de la liste num
         bsr        win_tst
         cmp.b      #1,d6                    ;Le joueur a-t-il perdu ?
         bne        input

         clr.w      d7
         lea        strlost(pc),a0 
         tst.b      stk_flag
         beq        the_end
         move.w     counter,d7
         clr.w      counter
         clr.b      stk_flag
         bra        the_end

win      lea        strwin(pc),a0
         tst.b      stk_flag
         bne        the_end
         clr.w      counter
         move.b     #1,stk_flag

the_end  addi.w     #1,counter 
         move.b     #1,end_flag

         move.w     #44,d5
         move.w     #42,d6
         move.w     #2,d3
         bsr        string                   ;Affiche YOU WIN / YOU LOOSE

         move.w     #42,d0
         move.w     #39,d1
         move.w     #76,d2
         move.w     #14,d3
         bsr        frame

         bsr        stk_str
         bsr        key_off

         tst.b      stk_flag
         bne        pause
         cmp.w      score3,d7                ;On vrifie le score
         bhi        place

pause    clr.w      d0                       ;Attend que le joueur
         bsr        get_key                  ;appuie sur une touche
         cmp.b      #$ff,d0
         beq        pause
         bra        ini_scr                  ;On retourne au dbut

place    move.w     #21,d0
         add.b      TI92X,d0
         move.w     #57,d1
         add.b      TI92Y,d1
         move.w     #108,d2
         move.w     #12,d3
         move.w     #1,d4
         jsr        graphlib::fill

         move.w     #31,d0
         move.w     #57,d1
         move.w     #98,d2
         bsr        frame

         move.w     #34,d5
         move.w     #61,d6
         clr.w      d3
         lea        name(pc),a0
         bsr        string                   ;Affiche "Enter your name :"

         move.w     d7,score3                ;On dtermine la place du joueur
         move.w     #5,d0                    ;et on gre les scores
         lea        name2,a0
         lea        name3,a1
         cmp.w      score2,d7
         bls        get_name  
         bsr        movestr
         move.w     score2,score3
         move.w     d7,score2
         move.w     #5,d0
         lea        name1,a0
         lea        name2,a1
         cmp.w      score1,d7
         bls        get_name
         bsr        movestr
         move.w     score1,score2
         move.w     d7,score1
         lea        name1,a1

get_name bsr        int_on
         move.w     #96,d1
         add.b      TI92X,d1
         move.w     #61,d2
         add.b      TI92Y,d2
         move.w     #5,d3
\nm_loop jsr        userlib::InputStr        ;Enter your name :
         tst.b      d0
         beq        \nm_loop

         bsr        movestr
         bra        _main                    ;On retourne au dbut

;======================================================================;
;                           Sous programmes                            ;
;======================================================================;

new_int  rte
 
int_on:  move.w     #$0700,d0
         trap       #1
         bclr.b     #2,($600001)
         move.l     old_int,($64)
         bset.b     #2,($600001)
         trap       #1
         rts
         
frame:   add.b      TI92X,d0                  
         add.b      TI92Y,d1
         move.w     d2,d4
         move.w     d3,d5
         clr.w      d3                       ;d0: X
         move.w     d1,d2                    ;d1: Y
         add.b      d5,d2                    ;d2: longueur
         jsr        graphlib::vert           ;d3: hauteur
         add.b      d4,d0
         jsr        graphlib::vert           ;d4  destroyed 
         move.w     d0,d2                    ;d5  destroyed
         sub.b      d4,d2
         jsr        graphlib::horiz
         add.b      d5,d1
         jsr        graphlib::horiz
         rts

print:   move.l     #str+3,a0                ;d0: Nombre  afficher
         clr.b      (a0)                     ;d5: X
\pr_loop divu       #10,d0                   ;d6: Y
         swap       d0                       ;d3: police
         add.b      #48,d0
         move.b     d0,-(a0)
         clr.w      d0
         swap       d0
         tst.w      d0
         bne        \pr_loop
         bsr        string
         rts

string:  add.b      TI92X,d5
         add.b      TI92Y,d6
         move.w     d3,-(a7)                 ;d5: X
         jsr        doorsos::FontSetSys      ;d6: Y
         move.w     #4,-(a7)                 ;d3: police
         move.l     a0,-(a7)
         move.w     d6,-(a7)
         move.w     d5,-(a7)
         jsr        doorsos::DrawStrXY
         lea        12(a7),a7
         rts

get_key: move.w     d0,($600018)
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         nop
         clr.w      d0
         move.b     ($60001B),d0
         rts

key_off: clr.w      d0                       ;attend que toutes les touches
         bsr        get_key                  ;soient relaches
         cmp.b      #$ff,d0
         bne        key_off
         move.l     #-1,d0
\wait    dbra       d0,\wait
         rts

on_off:  btst.b     #1,$60001A               ;Si [ON] est enfonce,
         bne        \on
         trap       #4                       ;on teint la calculette
\on      rts

movestr: move.b     (a0)+,(a1)+
         dbra.s      d0,movestr
         rts

stk_str: move.w     #11,d0
         add.b      TI92X,d0
         move.w     #92,d1
         add.b      TI92Y,d1
         move.w     #138,d2 
         move.w     #10,d3
         move.w     #1,d4
         jsr        graphlib::fill

         move.w     #11,d0
         move.w     #92,d1
         bsr        frame

         move.w     #13,d5
         move.w     #95,d6
         clr.w      d3
         lea        streak(pc),a0
         bsr        string                   ;Affiche "Streak :"

         move.w     counter,d0
         move.w     #43,d5
         move.w     #95,d6 
         bsr        print                    ;Affiche le compteur

         move.w     #45,d5
         move.w     counter,d0
\log     divu       #10,d0                   ;Dtermine l'abscisse de
         addi.b     #3,d5                    ;win(s) ou loss(es)
         swap       d0
         clr.w      d0
         swap       d0
         tst.b      d0
         bne       \log
         move.b     stk_flag,d0              ;stk_flag=0: a0 pointe "loss" 
         mulu       #14,d0                   ;stk_flag=0: a0 pointe "win"
         lea        stk_type(pc),a0
         move.l     a0,d1
         add.b      d0,d1
         cmp.w      #1,counter               ;counter>1 : a0 pointe sur 
         bls        \one                     ;"wins" ou "losses"
         addi.l     #6,d1
\one     move.l     d1,a0
         move.w     #95,d6
         bsr        string
         rts

get_num: lea        num(pc),a0               ;input d0=rang
         lsl.b      #1,d0                    ;output d0=valeur
         move.w     -2(a0,d0),d0
         rts

put_num: lea        num(pc),a0               ;input d4=rang
         move.b     d4,d0                    ;input d7=valeur
         lsl.b      #1,d0
         move.w     d7,-2(a0,d0)
         rts

win_tst  clr.w      d1                       ;output d6: nombre de briques
         clr.w      d6                       ;           restantes
         move.w     #6,d2                    ;output d1: nombre de colonnes
\sm_loop move.w     d2,d0                    ;           restantes avec plus
         add.w      #1,d0                    ;           d'une  brique              
         bsr        get_num
         add.w      d0,d6
         cmp.w      #1,d0
         bls        \end_sm
         add.w      #1,d1
\end_sm  dbra.s     d2,\sm_loop
         rts

erase:   movem.w    d2-d4,-(a7)              ;d0: colonne
         lea        xcol(pc),a0              ;d1: rang
         sub.b      #1,d0
         lsl.b      #1,d0
         move.w     0(a0,d0),d0
         add.b      TI92X,d0
         lea        yrow(pc),a0
         sub.b      #1,d1
         lsl.b      #1,d1
         move.w     0(a0,d1),d1
         add.b      TI92Y,d1
         move.w     #10,d2
         move.w     #3,d3
         move.w     #1,d4
         jsr        graphlib::fill
         movem.w    (a7)+,d2-d4
         rts

delay:   move.w     #2,d1
\delay   move.l     #-1,d0
\\delay  dbra       d0,\\delay
         dbra.s     d1,\delay
         rts

;======================================================================;
;                              Donnes                                 ;
;======================================================================;

_comment     dc.b       "Marienbad v1.1",0

num          ds.w       8
TI92X        dc.w       0
TI92Y        dc.w       0
str          dc.b       "   ",0
old_int      dc.l       1
name1        dc.b       "GdV",0,0,0          ;5 charactres maximum
name2        dc.b       "Lool",0,0
name3        dc.b       "Tom",0,0,0
score1       dc.w       2
score2       dc.w       1
score3       dc.w       0
counter      dc.w       0
stk_flag     dc.b       1
end_flag     dc.b       1
sprite       dc.w       3
             dc.w       2
             dc.w       %0111111111000000
             dc.w       %1110000011100000
             dc.w       %0111111111000000
title        dc.w       10
             dc.w       11
             dc.l       %11110001110000111000011111110001
             dc.l       %11110111111110111100011101111111
             dc.l       %00000111000011111100000001011011
             dc.l       %10000110110000101001100010100010
             dc.l       %10011001010001100010100110001101
             dc.l       %10000101011000000101111110001010
             dc.l       %01100010100110001010001010001001
             dc.l       %01100110001010011001010011000101
             dc.l       %00110000010101011000101001100010
             dc.l       %10011000101000101010000101110110
             dc.l       %00101001100101001100010100110000
             dc.l       %01010001100010111110001011110000
             dc.l       %10100010111000010101111000101111
             dc.l       %00010111110001010011000001010001
             dc.l       %10001010011000101011000010100010
             dc.l       %10100001010011100010100110010100
             dc.l       %11000101001100000101000110001010
             dc.l       %01100010100110001010001010000001
             dc.l       %01000110001010011001010011000101
             dc.l       %00110000010100011000101001100010
             dc.l       %10011000101000101000100101000110
             dc.l       %00101001100101001100010100110000
             dc.l       %01010001100010100110001010011000
             dc.l       %10100010100110010100011000101001
             dc.l       %10010100110001010110000011100000
             dc.l       %11011100001101110000110111110111
             dc.l       %11111011100000110111111100111000
             dc.w       %0110111111000000
xcol         dc.w       21,39,57,75,93,111,129
yrow         dc.w       73,65,57,49,41,33,25
streak       dc.b       "Streak :",0
stk_type     dc.b       " loss",0," losses",0," win ",0," wins",0,
strwin       dc.b       "You WIN !",0
strlost      dc.b       "You LOOSE",0
name         dc.b       "Enter your name :",0
version      dc.b       "v1.1 by GdV",0
colstr       dc.b       "1  2  3  4  5  6  7",0
ti           dc.b       "TI-     starts",0
player       dc.b       "Player starts",0

 end
